Subject: bug#15368: closed (Re: bug#15368: HTTP client is slow [2.0.9])

From: [email-masked] (GNU bug Tracking System)
Date: Fri, 23 May 2014 20:15:04 +0000

Your bug report

#15368: HTTP client is slow [2.0.9]

which was filed against the guile package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
15368: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=15368
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#15368: HTTP client is slow [2.0.9]
From: [email-masked] (Ludovic Courtès)
To: [email-masked]
Date: Fri, 23 May 2014 22:14:00 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

[email-masked] (Ludovic Courtès) skribis:

> Here I get a throughput of ~60 KiB/s, vs. ~400 KiB/s for wget and curl.

There’s one little detail I hadn’t even bothered checking:

          ;; Enlarge the receive buffer.
          (setsockopt s SOL_SOCKET SO_RCVBUF (* 12 1024))

Its effect was to *shrink* the receive buffer from 124 KiB (the default
size, per /proc/sys/net/core/rmem_default) to 12 KiB...

Fixed in 0bb3f94, which will be in 2.0.12.

Ludo’.

Subject: HTTP client is slow [2.0.9]
From: [email-masked] (Ludovic Courtès)
To: [email-masked]
Date: Fri, 13 Sep 2013 15:41:27 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

I just noticed that our HTTP client is very slow.  Consider this:

--8<---------------cut here---------------start------------->8---
(use-modules (web client)
             (rnrs io ports)
             (rnrs bytevectors)
             (srfi srfi-11)
             (ice-9 format))

(define %uri
  "http://ftp.gnu.org/gnu/idutils/idutils-4.6.tar.xz")

(with-fluids ((%default-port-encoding #f))
  (let*-values (((start)
                 (gettimeofday))
                ((p)
                 (let ((s (open-socket-for-uri %uri)))
                   (setvbuf s _IONBF)
                   s))
                ((r h)
                 (http-get %uri
                           #:port p
                           #:streaming? #t
                           #:decode-body? #f))
                ((d len)
                 (let ((b (get-bytevector-all h)))
                   (values b (bytevector-length b)))
                 ;; (let ((b (make-bytevector (* 5 (expt 2 20)))))
                 ;;   (values b
                 ;;           (get-bytevector-n! h b 0 (bytevector-length b))))
                 )
                ((end)
                 (gettimeofday))
                ((throughput)
                 (let ((duration (- (car end) (car start))))
                   (/ (/ len 1024.) duration 1.0))))
    (format #t "~5,1f KiB/s (total: ~5,1f KiB)~%"
            throughput (/ len 1024.))))
--8<---------------cut here---------------end--------------->8---

Here I get a throughput of ~60 KiB/s, vs. ~400 KiB/s for wget and curl.

Looking at the strace output reveals no real difference: they all make
one syscall for each chunk of 1410 bytes.

‘time’ reports that Guile spends 0.2 s. in user and 0.8 s. in system,
both of which are an order of magnitude higher than wget/curl.

Bypassing the custom binary input ports from http.scm and response.scm
doesn’t make any big difference.  Forcing the zero-copy path in
‘scm_c_read’ doesn’t help much either.

Ideas?

Thanks,
Ludo’.